""" A module mimicking some functionality of uflacs' modified terminals """

from ufl.algorithms import MultiFunction
from dune.perftool import Restriction


class ModifiedTerminalTracker(MultiFunction):
    def __init__(self):
        MultiFunction.__init__(self)
        self.grad = False
        self.reference_grad = False
        self.restriction = Restriction.NONE

    def positive_restricted(self, o):
        self.restriction = Restriction.POSITIVE
        ret = self.expr(o)
        self.restriction = Restriction.NONE
        return ret

    def negative_restricted(self, o):
        self.restriction = Restriction.NEGATIVE
        ret = self.expr(o)
        self.restriction = Restriction.NONE
        return ret

    def grad(self, o):
        self.grad = True
        ret = self.expr(o)
        self.grad = False
        return ret

    def reference_grad(self, o):
        self.reference_grad = True
        ret = self.expr(o)
        self.reference_grad = False
        return ret
